//+------------------------------------------------------------------+
//|                                                   TradeState.mqh |
//|                                 Copyright 2015, Vasiliy Sokolov. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Vasiliy Sokolov."
#property link      "http://www.mql5.com"

/*
    MetaTrader 5,  ,    ()
   ,     (1-2 .) 
       .    
          . 
        CTradeState. 
     ,    2  30 000 ,
       ( ChangedState()).
*/
//+------------------------------------------------------------------+
//|     ( RememberDeals),       |
//|     ,  ChangedState     |
//|  true.                                                 |
//+------------------------------------------------------------------+
class CTradeState
{
private:
   int      m_deals_count;
   int      m_limit_msc;
   bool     m_is_remember;
   bool     m_is_print;
   datetime StartTime(void);
public:
   CTradeState();
   void SetLimitWaitMsc(int limit);
   int GetLimitWaitMsc();
   void RememberDeals(void);
   bool ChangedState();
   void PrintSleeping(bool isPrint);
};
//+------------------------------------------------------------------+
//|   .                                        |
//+------------------------------------------------------------------+
CTradeState::CTradeState()
{
   m_deals_count = 0;
   m_limit_msc = 3000;
   m_is_remember = false;
   m_is_print = false;
}
//+------------------------------------------------------------------+
//|    .                 |
//+------------------------------------------------------------------+
void CTradeState::PrintSleeping(bool isPrint)
{
   m_is_print = isPrint;
}
//+------------------------------------------------------------------+
//|    ,   ,  |
//| ChangedState     .             |
//+------------------------------------------------------------------+
void CTradeState::SetLimitWaitMsc(int limit_msc)
{
   if(limit_msc < 0)
      m_limit_msc = 3000;
   if(limit_msc > 30000)
   {
      printf("Too large limit. Set 30000 msec.");
      m_limit_msc = 3000;
   }
   m_limit_msc = limit_msc;
}
//+------------------------------------------------------------------+
//|    ,   ,     |
//| ChangedState     .             |
//+------------------------------------------------------------------+
int CTradeState::GetLimitWaitMsc(void)
{
   return m_limit_msc;
}
//+------------------------------------------------------------------+
//|     //.   |
//+------------------------------------------------------------------+
datetime CTradeState::StartTime(void)
{
   return TimeCurrent() - GetTickCount()/1000;
}
//+------------------------------------------------------------------+
//|   .                                    |
//+------------------------------------------------------------------+
void CTradeState::RememberDeals(void)
{
//---   
   HistorySelect(StartTime(), TimeCurrent());
   m_deals_count = HistoryDealsTotal();
   m_is_remember = true;
//---   
}
//+------------------------------------------------------------------+
//|  ,      .                                    |
//+------------------------------------------------------------------+
bool CTradeState::ChangedState(void)
{
   if(!m_is_remember)
   {
      printf("State is not remember");
      return false;
   }
   for(int i = 1;;i++)
   {
      HistorySelect(StartTime(), TimeCurrent());
      int sleep = (int)MathPow(2, i);
      if(HistoryDealsTotal() != m_deals_count ||
         sleep > m_limit_msc)
      {
         m_is_remember = false;
         m_deals_count = 0;
         return sleep < m_limit_msc;
      }
      if(m_is_print)
         printf("Sleep " + (string)sleep + " milliseconds...");
      Sleep(sleep);
   }
   return false;
}
